<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/forms.inc.php');
	require_once(CI_PATH_LIBS.'/skype.inc.php');

	CI_AUTH::require_auth('admin', array('reply' => 'html'));

	$manager=new CI_SKYPE_FORWARDS();
	$info=$manager->get_info($_REQUEST['id']);

	$hidden_fields=array(
		'id'			=> $_REQUEST['id'],
		'task'			=> 'save',
		'destinations'	=> $info['destinations']
	);

	$profiles=array();
	$manager_profiles=new CI_SKYPE_PROFILES();
	$items=$manager_profiles->get_list();
	foreach ($items as $item) $profiles[$item['id']]=$item['desc'];

	$fields=array(
		'base'	=> array(
			'fields'	=> array(
				'skype_username'	=> array('type' => 'text'),
				'skype_password'	=> array('type' => 'password'),
				'desc'				=> array('type' => 'text'),
				'delay'				=> array('type' => 'int', 'note' => ci_lbl('skype.forwards.info.note-delay'), 'extra' => array('size' => 5)),
				'profile'			=> array('type' => 'select', 'options' => $profiles, 'null' => true),
				'enabled'			=> array('type' => 'yesno')
			)
		)
	);

	if (!$_REQUEST['id'])
	{
		$info['delay']=60;
	}

	$form=new CI_FORMS('form');
	$form->set_values($info);
	$form->set_action('actions/skype_forwards.php');
	$form->set_fields($fields);
	$form->set_hidden_fields($hidden_fields);
	$form->set_tabs_label_prefix('skype.forwards.info.tab-');
	$form->set_fields_label_prefix('skype.forwards.info.fld-');

	$buttons=new CI_BUTTONS();
	$buttons->add_stock_button('back');
	$buttons->add_stock_button('reset');
	if ($_REQUEST['id']) $buttons->add_stock_button('delete');
	$buttons->add_stock_button('save');
?>
<script type="text/javascript">
	function on_modal_results(id, res)
	{
		if ((id=="delete") && (res==true))
		{
			$('form').task.value="delete";
			$('form').do_submit();
			ci_load_page('skype/forwards/index.php');
		}
	}
	
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'back':	ci_load_page('skype/forwards/index.php'); break;
			case 'reset':	$('form').reset(); break;
			case 'save':	$('form').do_submit(); break;
			case 'delete':	ci_modal_confirm("delete", "<?php echo ci_lbl('skype.forwards.info.confirm-delete') ?>", "on_modal_results"); break;
		}
		ci_hide_error_block('form_error');
	}

	function on_form_event(id, task)
	{
	}

	function reload_destinations_list()
	{
		ci_show_loader();

		var ajx=new Ajax(ci_uri_base+'/skype/forwards/info_destinations.php?list='+escape($('form').destinations.value), {
			evalScripts:	true,
			method:			'get',
			update:			$('destinations_loader'),
			onComplete:		function() {
				ci_hide_loader();
			}
		}).request();
	}

	function on_table_event(table, task, id)
	{
		if (task == 'delete')
		{
			var items=$('form').destinations.value ? $('form').destinations.value.split(',') : new Array();
			$('form').destinations.value=ci_array_remove(items, id).join(',');
			reload_destinations_list();
		}
		else if (task == 'sort')
		{
			var items=$('form').destinations.value ? $('form').destinations.value.split(',') : new Array();
			
			items=ci_array_map_sort(items, id);
			$('form').destinations.value=items.join(',');
			reload_destinations_list();
		}
	}

	function on_destination_change()
	{
		name=$('new_destination').value;
		if (!name) return;
		
		var items=$('form').destinations.value ? $('form').destinations.value.split(',') : new Array();

		items.push(name);
		$('new_destination').value='';

		items=ci_array_unique(items);
		$('form').destinations.value=items.join(',');
		reload_destinations_list();
	}
</script>

<?php if ($_REQUEST['id']) { ?>
<div class="title"><?php echo ci_lbl("skype.forwards.info.title", array('name' => $info['skype_username'])) ?></div>
<?php } else { ?>
<div class="title"><?php echo ci_lbl("skype.forwards.info.title-new") ?></div>
<?php } ?>

<div class="help"><?php echo ci_hlp("skype.forwards.info") ?></div>

<?php echo $form->get() ?>

<div class="title2"><?php echo ci_lbl("skype.forwards.destinations") ?></div>
<div style="margin: 0 20px 0 20px; padding: 5px;">
	<div id="destinations_loader" style="margin-bottom: 10px"></div>

	<?php echo ci_lbl('skype.forwards.destination.new') ?><br />
	<input size="90" type="text" class="inputbox" id="new_destination" value="" />&nbsp;<input class="button" value="<?php echo ci_lbl('common.add') ?>" type="button" onclick="on_destination_change()" />

</div>

<?php echo $buttons->get() ?>

<script type="text/javascript">
	reload_destinations_list();
</script>

