<?php
	class CI_CONFIG
	{
		function CI_CONFIG()
		{
		}
		
		function get_raw_list()
		{
			$items=ci_get_unserialized_xml($this->get_config_file());
			if (!$items) return array();

			$items['item'] = ci_normalize_xml_array($items['item']);
// 			if (!$items['item'][0]) $items['item']=array($items['item']);

			return $items['item'];
		}

		function get_list()
		{
			$list =& $this->get_raw_list();

			for ($i=0; $i<sizeof($list); $i++) $list[$i]=$this->get_map($list[$i]);
			return $list;
		}

		function get_raw_info($id)
		{
			$list =& $this->get_raw_list();
			for ($i=0; $i<sizeof($list); $i++)
			{
				if ($list[$i]['id'] == $id) return $list[$i];
			}
			return array();
		}

		function get_info($id)
		{
			return $this->get_map($this->get_raw_info($id));
		}

		function get_n($id)
		{
			$list =& $this->get_list();
			for ($i=0; $i<sizeof($list); $i++)
			{
				if ($list[$i]['id'] == $id) return $i;
			}

			return sizeof($list);
		}

		function get_id_by_pos($n)
		{
			$list =& $this->get_list();
			return $list[$n]['id'];
		}

		function save_config($array)
		{
			$array2=array();
			for ($i=0; $i<sizeof($array); $i++)
			{
				if ($array[$i]) array_push($array2, $this->get_rmap($array[$i]));
			}

			$this->save_raw_config($array2);
		}

		function save_raw_config($array)
		{
			if (!sizeof($array))
				$array2=array();
			else
				$array2['item'] =& $array;

			ci_save_xml($this->get_config_file(), $array2);
			return ci_response_ok();
		}

		function task_delete($id)
		{
			$list =& $this->get_list();
			$list2=array();
			
			for ($i=0; $i<sizeof($list); $i++)
			{
				if ($list[$i]['id'] != $id)
				{
					array_push($list2, $list[$i]);
				}
			}
			
			$this->save_config($list2);
			return ci_response_ok();
		}

		function task_toggle($id)
		{
			$list =& $this->get_list();
			for ($i=0; $i<sizeof($list); $i++)
			{
				if ($list[$i]['id'] == $id)
				{
					$list[$i]['enabled']=($list[$i]['enabled'] == 'true') ? 'false' : 'true';
					break;
				}
			}

			$this->save_config($list);
			return ci_response_ok();
		}

		function task_sort($map)
		{
			if (!$map) return ci_response_ok();
			
			$list = $this->get_list();
			$map = split(',', $map);

			if (!sizeof($map)) return ci_response_ok();

			$out=array();
			for ($i=0; $i<sizeof($map); $i++) $out[$i]=$list[$map[$i]];

			$this->save_config($out);
			return ci_response_ok();
		}
	}
?>