<?php
	require_once(CI_PATH_LIBS.'/igx.inc.php');
	
	class CI_SETTINGS_FEATURES extends CI_SETTINGS
	{
		function get_config_file()
		{
			return IGX_PATH_BASE.'/config/features.xml';
		}

		function get_rmap($info)
		{
			return array(
				'auth-user-len'				=> $info['auth_user_len'],
				'auth-password-len'			=> $info['auth_password_len'],
				'auth-sequence'				=> $info['auth_sequence'],

				'command-open'				=> $info['command_open'],
				'command-close'				=> $info['command_close'],

				'commands' 	=> array(
					'conference-start'		=> $info['command_conference_start'],
					'conference-finish'		=> $info['command_conference_finish'],
					'inline-login'			=> $info['command_inline_login'],
					'inline-logout'			=> $info['command_inline_logout'],
					'onhold'				=> $info['command_onhold'],
					'resume'				=> $info['command_resume']
				)
			);
		}

		function get_map($info)
		{
			return array(
				'auth_user_len'				=> $info['auth-user-len'],
				'auth_password_len'			=> $info['auth-password-len'],
				'auth_sequence'				=> $info['auth-sequence'],

				'command_open'				=> $info['command-open'],
				'command_close'				=> $info['command-close'],

				'command_conference_start'	=> $info['commands']['conference-start'],
				'command_conference_finish'	=> $info['commands']['conference-finish'],

				'command_inline_login'		=> $info['commands']['inline-login'],
				'command_inline_logout'		=> $info['commands']['inline-logout'],

				'command_onhold'			=> $info['commands']['onhold'],
				'command_resume'			=> $info['commands']['resume']
			);
		}
		
		function get_info()
		{
			$config=ci_get_unserialized_xml($this->get_config_file());
			return $this->get_map($config);
		}

		function task_save($info)
		{
			CI_IGX::set_flag_reload();
			
			ci_save_xml($this->get_config_file(), $this->get_rmap($info));
			return ci_response_ok();
		}
	}
?>