#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path
import string
import re
import time
import httplib
import urllib
from urlparse import urlparse

from xml.sax import saxutils

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from castiron import *

# Variables replace
def set_vars(txt, replace):
	if not txt: txt=""

	for k in replace.keys():

		if not replace[k]: replace[k]=""
		txt=re.sub(r'\$\{'+k+'\}', replace[k], txt)

	return txt

# Check config parameters
CORE_CONF_SYSTEM		= xml_to_array(CORE_PATH_BASE+'/config/system.xml')
CASTIRON_CONF_MISC		= xml_to_array(CASTIRON_PATH_BASE+'/config/misc.xml')

if os.path.isfile(CASTIRON_PATH_BASE+'/data/chatmessage_incoming_received.evt'):

	fp=open(CASTIRON_PATH_BASE+'/data/chatmessage_incoming_received.event', 'r')
	url=re.sub(r'[\n\r]', '', fp.read())
	fp.close()

	try:
		o = urlparse(url)

		params	= urllib.urlencode(os.environ)
		headers	= {"Content-type": "application/x-www-form-urlencoded"}

		if o.port:
			conn = httplib.HTTPConnection(o.hostname+':'+str(o.port))
		else:
			conn = httplib.HTTPConnection(o.hostname)

		qsa={}
		for k in os.environ.keys():
			qsa[k]=urllib.quote(os.environ[k])

		qs=set_vars(o.query, qsa)

		conn.request("POST", o.path+'?'+qs, params, headers)
		res=conn.getresponse()

		data = res.read()
		res.close()

	except:
		sys.exit(-1)
	
else:

	if not CASTIRON_CONF_MISC.has_key('chat-autoanswer'): sys.exit(0)

	if CASTIRON_CONF_MISC['chat-autoanswer']['enabled'] != 'true': sys.exit(0)
	if not CASTIRON_CONF_MISC['chat-autoanswer']['text']: sys.exit(-1)

	user_name = os.environ['user_name']

	# System environ
	fp=open('/etc/hostname', 'r')
	hostname=re.sub(r'[\n\r]+', '', fp.read())
	fp.close()

	# Variables
	sys_vars={
		'sysname':			CORE_CONF_SYSTEM['hq']['sysname'],
		'server':			hostname,
		'hostname':			hostname,
		'date-time':		time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
	}

	# Replacement
	text = set_vars(CASTIRON_CONF_MISC['chat-autoanswer']['text'], sys_vars)

	print '<?xml version="1.0" encoding="UTF-8"?>'
	print '<actions>'
	print '<action to="skype" name="chatmessage-send">'
	print '<arg name="user-name">'+s2p_xml_escape(user_name)+'</arg>'
	print '<arg name="message-body">'+s2p_xml_escape(text)+'</arg>'
	print '</action>'
	print '<action to="skype" name="chat-leave" />'
	print '</actions>'





