#!/bin/bash

cd `dirname $0`
MYDIR=`pwd`
MYSCRIPT=`basename $0`
cd ../..
S2P_PATH_BASE=`pwd`
cd $MYDIR

S2P_OS_USERNAME=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^os.username | cut -d= -f2`

if [[ `whoami` != "$S2P_OS_USERNAME" ]]; then
	exec sudo -u $S2P_OS_USERNAME ./$MYSCRIPT $@
fi

usage()
{
	echo "Usage: $0 username password vncscreen"
	cd $OWD

	exit -1
}

if [ -z "$1" ]; then
	usage
fi
if [ -z "$2" ]; then
	usage
fi
if [ -z "$3" ]; then
	usage
fi

CONFIG_USER=$1
CONFIG_PASS=$2
CONFIG_VNC=$3

CONFIG_ID=`date +%Y%m%d%H%M%S`
CONFIG_ID="$CONFIG_USER-$CONFIG_ID-$CONFIG_VNC"

SKYPE_CONFIG=`cat $S2P_PATH_BASE/core/config/skype.xml|grep -v ^\</config\>$`

cat << __EOF__ > $S2P_PATH_BASE/core/config/skype.xml
$SKYPE_CONFIG
	<item>
		<id>$CONFIG_ID</id>
		<desc>Account $CONFIG_USER</desc>
		<skype>
			<username>$CONFIG_USER</username>
			<password>$CONFIG_PASS</password>
		</skype>
		<vnc>
			<screen>$CONFIG_VNC</screen>
			<password>$CONFIG_PASS</password>
		</vnc>
		<enabled>true</enabled>
		<filetransfer>
			<enabled>false</enabled>
		</filetransfer>
		<userdata>
			<igx-master-account>false</igx-master-account>
			<castiron-filetransfer-media />
			<castiron-filetransfer-message-template-subject />
			<castiron-filetransfer-message-template-body />
			<castiron-caller-prefix />
			<castiron-fallback />
		</userdata>
		<audio>
			<agc>true</agc>
			<aec>true</aec>
		</audio>
		<profile />
	</item>
</config>
__EOF__

exit 0
